<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_PackageAdditionalElement ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_PackageAdditionalElement extends AbstractStructArrayBase
{
    /**
     * The PackageSupplement
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_PackageAdditionalElement[]
     */
    public $PackageSupplement;
    /**
     * Constructor method for ArrayOfJP_PackageAdditionalElement
     * @uses ArrayOfJP_PackageAdditionalElement::setPackageSupplement()
     * @param \StructType\JP_PackageAdditionalElement[] $packageSupplement
     */
    public function __construct(array $packageSupplement = array())
    {
        $this
            ->setPackageSupplement($packageSupplement);
    }
    /**
     * Get PackageSupplement value
     * @return \StructType\JP_PackageAdditionalElement[]|null
     */
    public function getPackageSupplement()
    {
        return $this->PackageSupplement;
    }
    /**
     * This method is responsible for validating the values passed to the setPackageSupplement method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPackageSupplement method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePackageSupplementForArrayConstraintsFromSetPackageSupplement(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_PackageAdditionalElementPackageSupplementItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_PackageAdditionalElementPackageSupplementItem instanceof \StructType\JP_PackageAdditionalElement) {
                $invalidValues[] = is_object($arrayOfJP_PackageAdditionalElementPackageSupplementItem) ? get_class($arrayOfJP_PackageAdditionalElementPackageSupplementItem) : sprintf('%s(%s)', gettype($arrayOfJP_PackageAdditionalElementPackageSupplementItem), var_export($arrayOfJP_PackageAdditionalElementPackageSupplementItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PackageSupplement property can only contain items of type \StructType\JP_PackageAdditionalElement, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PackageSupplement value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_PackageAdditionalElement[] $packageSupplement
     * @return \ArrayType\ArrayOfJP_PackageAdditionalElement
     */
    public function setPackageSupplement(array $packageSupplement = array())
    {
        // validation for constraint: array
        if ('' !== ($packageSupplementArrayErrorMessage = self::validatePackageSupplementForArrayConstraintsFromSetPackageSupplement($packageSupplement))) {
            throw new \InvalidArgumentException($packageSupplementArrayErrorMessage, __LINE__);
        }
        $this->PackageSupplement = $packageSupplement;
        return $this;
    }
    /**
     * Add item to PackageSupplement value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_PackageAdditionalElement $item
     * @return \ArrayType\ArrayOfJP_PackageAdditionalElement
     */
    public function addToPackageSupplement(\StructType\JP_PackageAdditionalElement $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_PackageAdditionalElement) {
            throw new \InvalidArgumentException(sprintf('The PackageSupplement property can only contain items of type \StructType\JP_PackageAdditionalElement, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PackageSupplement[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_PackageAdditionalElement|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_PackageAdditionalElement|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_PackageAdditionalElement|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_PackageAdditionalElement|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_PackageAdditionalElement|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PackageSupplement
     */
    public function getAttributeName()
    {
        return 'PackageSupplement';
    }
}
